// VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VC.h"
#include "VCDlg.h"
#include "math.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDlg dialog

CVCDlg::CVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDlg)
	m_volt = 2.0f;
	m_offset = 0.0f;
	m_frequency = 1000.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nDeviceIndex = 0;
	m_nConnect = 0;
	m_nWavePointNum = 4096;
	m_nWavePeriodNum = 1;
	m_bDownload = 0;
	m_nDeviceIndex = 0;
}

void CVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDlg)
	DDX_Control(pDX, IDC_STATIC_STATUS, m_status);
	DDX_Text(pDX, IDC_EDIT_AMP, m_volt);
	DDV_MinMaxFloat(pDX, m_volt, 0.f, 3.5f);
	DDX_Text(pDX, IDC_EDIT_OFFSET, m_offset);
	DDV_MinMaxFloat(pDX, m_offset, -3.5f, 3.5f);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_frequency);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_DOWNLOAD, OnBtnDownload)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_EDIT_AMP, OnChangeEditAmp)
	ON_EN_CHANGE(IDC_EDIT_FREQ, OnChangeEditFreq)
	ON_EN_CHANGE(IDC_EDIT_OFFSET, OnChangeEditOffset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDlg message handlers

BOOL CVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//Search for device
	SetTimer(1, 50, NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCDlg::OnBtnDownload() 
{
	// TODO: Add your control notification handler code here
	if (0 == m_nConnect)
		return;	
	//Download waveform to hardware
	m_bDownload = true;
}


void CVCDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString sTmp;

	if (0 == m_nConnect)
	{
		m_nConnect = dsoHTDeviceConnect(m_nDeviceIndex);
		if(m_nConnect == 1)
		{
			ddsSetOnOff(m_nDeviceIndex,1);
		}
		sTmp = "No Item!";		
	}
	else
	{
		
		sTmp.Format("%d Items", m_nConnect);
		//Download waveform
		Download();
		if (!dsoHTDeviceConnect(m_nDeviceIndex))
		{
			m_nConnect = 0;
		}
	}
	m_status.SetWindowText(sTmp);
	CDialog::OnTimer(nIDEvent);
}
void CVCDlg::Download()
{
	if (0 == m_bDownload)
		return;
	m_bDownload = 0;
	UpdateData(TRUE);
	//Set Frequency
	ddsSetFrequency(m_nDeviceIndex, m_frequency, &m_nWavePointNum, &m_nWavePeriodNum);
	//Create waveform buffer
	CreateWave();
	ddsDownload(m_nDeviceIndex, m_nWavePointNum, buffer);	
}


void CVCDlg::CreateWave()
{
	int i;
	float tmp;
	for (i = 0; i < m_nWavePointNum; i++)
	{
		tmp=float(m_offset*1.0/MAX_VOLT
			+m_volt/MAX_VOLT*sin((i*1.0/m_nWavePointNum)*2*3.14159f*m_nWavePeriodNum));	
		tmp = 2048-2047*tmp;
		if (tmp > 4095)
			tmp = 4095;
		else if (tmp < 0)
			tmp = 0;	
		buffer[i] = USHORT(tmp);
	}
}

void CVCDlg::OnChangeEditAmp() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if (UpdateData(true))
		UpdateData(false);
}

void CVCDlg::OnChangeEditFreq() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if (UpdateData(true))
		UpdateData(false);
}

void CVCDlg::OnChangeEditOffset() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if (UpdateData(true))
		UpdateData(false);
}
